/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package launcher;
/*

 * To change this template, choose Tools | Templates

 * and open the template in the editor.

 */

import java.io.File;
import java.io.IOException;
import java.net.ServerSocket;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.glassfish.api.ActionReport;
import org.glassfish.api.ActionReport.MessagePart;
import org.glassfish.api.admin.CommandRunner;
import org.glassfish.api.admin.ParameterMap;
import org.glassfish.api.deployment.DeployCommandParameters;
import org.glassfish.api.embedded.ContainerBuilder;
import org.glassfish.api.embedded.EmbeddedDeployer;
import org.glassfish.api.embedded.LifecycleException;
import org.glassfish.api.embedded.Server;

/**
 *
 * @author pk033
 */
public class Launch {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws LifecycleException, IOException, InterruptedException, Throwable {


        Server server = null;
        EmbeddedDeployer deployer = null;
        try {
            server = startServer(8080);

            createUsers(server);

            deployer = server.getDeployer();
            log.info("Deploying ");
            String appName = null;
            DeployCommandParameters params = new DeployCommandParameters();
            appName = deployer.deploy(new File(args[0]), params);
            log.log(Level.INFO, "Deployed {0}", appName);

            ServerSocket servSocker = new ServerSocket(8081);
            servSocker.accept().close();
            servSocker.close();

        } finally {
            if (deployer != null) {
                deployer.undeployAll();
            }
            if (server != null) {
                server.stop();
            }

        }
    }

    private static Server startServer(int port) throws LifecycleException, IOException {
        Server.Builder builder = new Server.Builder("test");

        builder.logger(true);
        Server server = builder.build();
        server.addContainer(ContainerBuilder.Type.web);
        server.start();

        // Specify the port
        server.createPort(port);

        return server;

    }

    private static List<MessagePart> asAdmin(Server server, String command, ParameterMap params) throws Throwable {
        CommandRunner runner = server.getHabitat().getComponent(CommandRunner.class);
        ActionReport report = server.getHabitat().getComponent(ActionReport.class);
        log.log(Level.INFO, "Invoke {0} {1}", new Object[]{command, params});

        if (params == null) {
            runner.getCommandInvocation(command, report).execute();
        } else {
            runner.getCommandInvocation(command, report).parameters(params).execute();
        }

        log.log(Level.INFO, "command finished with {0}", report.getActionExitCode());

        if (report.hasFailures()) {
            if (report.getFailureCause() != null) {
                throw report.getFailureCause();
            } else {
                throw new Exception(report.getMessage());
            }
        }

        return report.getTopMessagePart().getChildren();
    }

    private static void createUsers(Server server) throws Throwable {
        ParameterMap params = new ParameterMap();

        params.add("username", "admin");
        params.add("userpassword", "admin");

        params.add("groups", "TEST2");
        params.add("groups", "TEST1");

        asAdmin(server, "create-file-user", params);
    }
    private static final Logger log = Logger.getLogger(Launch.class.getName());


}
